Index: /trunk/ReleaseNotes
===================================================================
--- /trunk/ReleaseNotes	(revision 213)
+++ /trunk/ReleaseNotes	(revision 214)
@@ -1,3 +1,6 @@
 * Actual Version:
+
+- replaced cvmatrix by Matrix
+- added a timeout on SimuBldc: if nothing is sent within the timeout, motors will stop
 
 -----------------------------------------------------------
Index: /trunk/demos/CircleFollower/uav/src/CircleFollower.cpp
===================================================================
--- /trunk/demos/CircleFollower/uav/src/CircleFollower.cpp	(revision 213)
+++ /trunk/demos/CircleFollower/uav/src/CircleFollower.cpp	(revision 214)
@@ -24,4 +24,5 @@
 #include <MetaVrpnObject.h>
 #include <TrajectoryGenerator2DCircle.h>
+#include <Matrix.h>
 #include <cvmatrix.h>
 #include <cmath>
@@ -61,9 +62,9 @@
 
     circle=new TrajectoryGenerator2DCircle(vrpnclient->GetLayout()->NewRow(),"circle");
-    uavVrpn->xPlot()->AddCurve(circle->Matrix()->Element(0,0),DataPlot::Blue);
-    uavVrpn->yPlot()->AddCurve(circle->Matrix()->Element(0,1),DataPlot::Blue);
-    uavVrpn->VxPlot()->AddCurve(circle->Matrix()->Element(1,0),DataPlot::Blue);
-    uavVrpn->VyPlot()->AddCurve(circle->Matrix()->Element(1,1),DataPlot::Blue);
-    uavVrpn->XyPlot()->AddCurve(circle->Matrix()->Element(0,1),circle->Matrix()->Element(0,0),DataPlot::Blue,"circle");
+    uavVrpn->xPlot()->AddCurve(circle->GetMatrix()->Element(0,0),DataPlot::Blue);
+    uavVrpn->yPlot()->AddCurve(circle->GetMatrix()->Element(0,1),DataPlot::Blue);
+    uavVrpn->VxPlot()->AddCurve(circle->GetMatrix()->Element(1,0),DataPlot::Blue);
+    uavVrpn->VyPlot()->AddCurve(circle->GetMatrix()->Element(1,1),DataPlot::Blue);
+    uavVrpn->XyPlot()->AddCurve(circle->GetMatrix()->Element(0,1),circle->GetMatrix()->Element(0,0),DataPlot::Blue,"circle");
 
     uX=new Pid(setupLawTab->At(1,0),"u_x");
Index: /trunk/demos/OpticalFlow/uav/src/DemoOpticalFlow.cpp
===================================================================
--- /trunk/demos/OpticalFlow/uav/src/DemoOpticalFlow.cpp	(revision 213)
+++ /trunk/demos/OpticalFlow/uav/src/DemoOpticalFlow.cpp	(revision 214)
@@ -22,5 +22,5 @@
 #include <LowPassFilter.h>
 #include <EulerDerivative.h>
-#include <cvmatrix.h>
+#include <Matrix.h>
 #include <GridLayout.h>
 #include <DataPlot1D.h>
@@ -65,7 +65,7 @@
   opticalFlowSpeedRaw=new OpticalFlowSpeed(opticalFlowCompensated,uav->GetAhrs(),uav->GetVerticalCamera()->GetLayout()->NewRow(),"vitesse du Flux Optique");
   //opticalFlowSpeed=vitesse de déplacement en pixels par seconde (moyenne sur tous les points et division par le delta T)
-  cvmatrix* twoByOneOFS=new cvmatrix((const Thread*)this,2,1,floatType);
-  cvmatrix* twoByOneOFAR=new cvmatrix((const Thread*)this,2,1,floatType);
-  cvmatrix* twoByOneOFA=new cvmatrix((const Thread*)this,2,1,floatType);
+  Matrix* twoByOneOFS=new Matrix((const Thread*)this,2,1,floatType);
+  Matrix* twoByOneOFAR=new Matrix((const Thread*)this,2,1,floatType);
+  Matrix* twoByOneOFA=new Matrix((const Thread*)this,2,1,floatType);
   opticalFlowSpeed=new LowPassFilter(opticalFlowSpeedRaw,uav->GetVerticalCamera()->GetLayout()->NewRow(),"Speed lowPass",twoByOneOFS);
   opticalFlowAccelerationRaw=new EulerDerivative(opticalFlowSpeed,uav->GetVerticalCamera()->GetLayout()->NewRow(),"derivative",twoByOneOFAR);
@@ -83,7 +83,7 @@
 
   xVelocityPlot->AddCurve(opticalFlowSpeedRaw->Output()->Element(0,0));
-  xVelocityPlot->AddCurve(opticalFlowSpeed->Matrix()->Element(0,0),DataPlot::Blue);
+  xVelocityPlot->AddCurve(opticalFlowSpeed->GetMatrix()->Element(0,0),DataPlot::Blue);
   yVelocityPlot->AddCurve(opticalFlowSpeedRaw->Output()->Element(1,0));
-  yVelocityPlot->AddCurve(opticalFlowSpeed->Matrix()->Element(1,0),DataPlot::Blue);
+  yVelocityPlot->AddCurve(opticalFlowSpeed->GetMatrix()->Element(1,0),DataPlot::Blue);
   xFirstPointPlot->AddCurve(opticalFlowCompensated->GetFirstPointDisplacement()->Element(0,0));
   xFirstPointPlot->AddCurve(opticalFlowCompensated->GetFirstPointDisplacement()->Element(1,0),DataPlot::Blue);
@@ -107,7 +107,7 @@
   
   Tab* opticalFlowRealTab=new Tab(getFrameworkManager()->GetTabWidget(),"real speed");
-  opticalFlowRealSpeed=new cvmatrix((const Thread*)this,2,1,floatType);
-  opticalFlowReference=new cvmatrix((const Thread*)this,2,1,floatType);
-  opticalFlowRealAcceleration=new cvmatrix((const Thread*)this,2,1,floatType);
+  opticalFlowRealSpeed=new Matrix((const Thread*)this,2,1,floatType);
+  opticalFlowReference=new Matrix((const Thread*)this,2,1,floatType);
+  opticalFlowRealAcceleration=new Matrix((const Thread*)this,2,1,floatType);
   DataPlot1D* xRealVelocityPlot=new DataPlot1D(opticalFlowRealTab->NewRow(),"x speed (m/s)",-2,2);
   DataPlot1D* yRealVelocityPlot=new DataPlot1D(opticalFlowRealTab->LastRowLastCol(),"y speed (m/s)",-2,2);
Index: /trunk/demos/OpticalFlow/uav/src/DemoOpticalFlow.h
===================================================================
--- /trunk/demos/OpticalFlow/uav/src/DemoOpticalFlow.h	(revision 213)
+++ /trunk/demos/OpticalFlow/uav/src/DemoOpticalFlow.h	(revision 214)
@@ -20,5 +20,5 @@
 namespace flair {
     namespace core {
-        class cvmatrix;
+        class Matrix;
     }
     namespace gui {
@@ -55,9 +55,9 @@
         flair::gui::GroupBox* opticalFlowGroupBox;
         flair::gui::DoubleSpinBox *maxXSpeed,*maxYSpeed;
-        flair::core::cvmatrix *opticalFlowReference;
+        flair::core::Matrix *opticalFlowReference;
         flair::filter::Pid *u_x, *u_y;
         flair::filter::CvtColor* greyCameraImage;
         flair::core::AhrsData *customReferenceOrientation;
-        flair::core::cvmatrix *opticalFlowRealSpeed,*opticalFlowRealAcceleration;
+        flair::core::Matrix *opticalFlowRealSpeed,*opticalFlowRealAcceleration;
 
     private:
Index: /trunk/demos/SimpleFleet/uav/src/SimpleFleet.cpp
===================================================================
--- /trunk/demos/SimpleFleet/uav/src/SimpleFleet.cpp	(revision 213)
+++ /trunk/demos/SimpleFleet/uav/src/SimpleFleet.cpp	(revision 214)
@@ -29,4 +29,5 @@
 #include <PidThrust.h>
 #include <Euler.h>
+#include <Matrix.h>
 #include <cvmatrix.h>
 #include <AhrsData.h>
@@ -60,8 +61,8 @@
 
     circle=new TrajectoryGenerator2DCircle(vrpnclient->GetLayout()->NewRow(),"circle");
-    uavVrpn->xPlot()->AddCurve(circle->Matrix()->Element(0,0),0,0,255);
-    uavVrpn->yPlot()->AddCurve(circle->Matrix()->Element(0,1),0,0,255);
-    uavVrpn->VxPlot()->AddCurve(circle->Matrix()->Element(1,0),0,0,255);
-    uavVrpn->VyPlot()->AddCurve(circle->Matrix()->Element(1,1),0,0,255);
+    uavVrpn->xPlot()->AddCurve(circle->GetMatrix()->Element(0,0),0,0,255);
+    uavVrpn->yPlot()->AddCurve(circle->GetMatrix()->Element(0,1),0,0,255);
+    uavVrpn->VxPlot()->AddCurve(circle->GetMatrix()->Element(1,0),0,0,255);
+    uavVrpn->VyPlot()->AddCurve(circle->GetMatrix()->Element(1,1),0,0,255);
 
     xCircleCenter=new DoubleSpinBox(vrpnclient->GetLayout()->NewRow(),"x circle center"," m",-5,5,0.1,1,0);
Index: /trunk/demos/Sinus/src/Loop.cpp
===================================================================
--- /trunk/demos/Sinus/src/Loop.cpp	(revision 213)
+++ /trunk/demos/Sinus/src/Loop.cpp	(revision 214)
@@ -24,5 +24,5 @@
 #include <PushButton.h>
 #include <DataPlot1D.h>
-#include <cvmatrix.h>
+#include <Matrix.h>
 
 using namespace std;
@@ -47,5 +47,5 @@
                                    "1st order lawpass filter");
   sinus->GetPlot()->AddCurve(
-      firstLowPass->Matrix()->Element(0),
+      firstLowPass->GetMatrix()->Element(0),
       DataPlot::Blue); // add output of the filter to signal's graph
 
@@ -54,5 +54,5 @@
       sinus, sinus->GetSetupLayout()->NewRow(), "3rd order lawpass filter", 3);
   sinus->GetPlot()->AddCurve(
-      thirdLowPass->Matrix()->Element(0),
+      thirdLowPass->GetMatrix()->Element(0),
       DataPlot::Yellow); // add output of the filter to signal's graph
 
Index: /trunk/demos/Sinus/src/MeanFilter.cpp
===================================================================
--- /trunk/demos/Sinus/src/MeanFilter.cpp	(revision 213)
+++ /trunk/demos/Sinus/src/MeanFilter.cpp	(revision 214)
@@ -13,5 +13,5 @@
 
 #include "MeanFilter.h"
-#include <cvmatrix.h>
+#include <Matrix.h>
 #include <LayoutPosition.h>
 #include <GroupBox.h>
@@ -42,5 +42,5 @@
   desc->SetElementName(0, 0,
                        "mean filter"); // name will be used for graphs and logs
-  output = new cvmatrix(this, desc, floatType, name);
+  output = new Matrix(this, desc, floatType, name);
   delete desc;
 
@@ -52,5 +52,5 @@
 MeanFilter::~MeanFilter() {}
 
-cvmatrix *MeanFilter::GetMatrix() const { return output; }
+Matrix *MeanFilter::GetMatrix() const { return output; }
 
 float MeanFilter::GetValue(void) const { return output->Value(0, 0); }
@@ -64,6 +64,11 @@
 
   float result = 0;
-  // get input argument in a cvmatrix
-  cvmatrix *input = (cvmatrix *)data;
+  // get input argument in a matrix
+  const Matrix* input = dynamic_cast<const Matrix*>(data);
+  
+  if (!input) {
+      Warn("casting %s to Matrix failed\n",data->ObjectName().c_str());
+      return;
+  }
 
   // simple (and not efficent!) implementation of the filter
Index: /trunk/demos/Sinus/src/MeanFilter.h
===================================================================
--- /trunk/demos/Sinus/src/MeanFilter.h	(revision 213)
+++ /trunk/demos/Sinus/src/MeanFilter.h	(revision 214)
@@ -25,5 +25,5 @@
 namespace flair {
 namespace core {
-class cvmatrix;
+class Matrix;
 }
 namespace gui {
@@ -70,5 +70,5 @@
   * \return pointer to the output matrix
   */
-  core::cvmatrix *GetMatrix(void) const;
+  core::Matrix *GetMatrix(void) const;
 
   /*!
@@ -86,5 +86,5 @@
   gui::GroupBox *groupBox;
   gui::SpinBox *numberOfElements;
-  core::cvmatrix *output;
+  core::Matrix *output;
   float previousValues[MAX_NUMBER_OF_ELEMENTS]; // previous values storage
 };
Index: /trunk/demos/Sinus/src/Sinus.cpp
===================================================================
--- /trunk/demos/Sinus/src/Sinus.cpp	(revision 213)
+++ /trunk/demos/Sinus/src/Sinus.cpp	(revision 214)
@@ -21,5 +21,5 @@
 #include <SpinBox.h>
 #include <DataPlot1D.h>
-#include <cvmatrix.h>
+#include <Matrix.h>
 #include <math.h>
 
@@ -41,5 +41,5 @@
   cvmatrix_descriptor *desc = new cvmatrix_descriptor(1, 1);
   desc->SetElementName(0, 0, "value"); // name will be used for graphs and logs
-  output = new cvmatrix((IODevice *)this, desc, floatType, name);
+  output = new Matrix((IODevice *)this, desc, floatType, name);
   delete desc;
 
@@ -94,5 +94,5 @@
 }
 
-cvmatrix *Sinus::GetMatrix(void) const { return output; }
+Matrix *Sinus::GetMatrix(void) const { return output; }
 
 float Sinus::GetValue(void) const { return output->Value(0, 0); }
Index: /trunk/demos/Sinus/src/Sinus.h
===================================================================
--- /trunk/demos/Sinus/src/Sinus.h	(revision 213)
+++ /trunk/demos/Sinus/src/Sinus.h	(revision 214)
@@ -23,5 +23,5 @@
 namespace core {
 class FrameworkManager;
-class cvmatrix;
+class Matrix;
 }
 namespace gui {
@@ -69,5 +69,5 @@
   * \return un pointeur vers la matrice de sortie
   */
-  core::cvmatrix *GetMatrix(void) const;
+  core::Matrix *GetMatrix(void) const;
 
   /*!
@@ -113,5 +113,5 @@
   void Run(void);
 
-  core::cvmatrix *output;
+  core::Matrix *output;
   gui::Tab *mainTab;
   gui::TabWidget *tabWidget;
Index: /trunk/lib/FlairCore/src/FrameworkManager_impl.cpp
===================================================================
--- /trunk/lib/FlairCore/src/FrameworkManager_impl.cpp	(revision 213)
+++ /trunk/lib/FlairCore/src/FrameworkManager_impl.cpp	(revision 214)
@@ -211,5 +211,5 @@
   }
 																							
-	UDT::startup();
+	UDT::startup(1024*256,1024*256,1024*256);
   this->rcv_buf_size = rcv_buf_size;
 
Index: /trunk/lib/FlairCore/src/Matrix.cpp
===================================================================
--- /trunk/lib/FlairCore/src/Matrix.cpp	(revision 213)
+++ /trunk/lib/FlairCore/src/Matrix.cpp	(revision 214)
@@ -19,6 +19,4 @@
 #include <typeinfo>
 #include <string.h>
-
-//#include <iostream>
 
 using std::string;
@@ -37,5 +35,5 @@
     this->col = col;
     if (row >= matrix->Rows() || col >= matrix->Cols()) {
-      matrix->Err("index (%i,%i) out of bound (%i,%i)\n", row, col,
+      matrix->Err("index (%i,%i) out of bound, max (%i,%i)\n", row, col,
                   matrix->Rows() - 1, matrix->Cols() - 1);
       size = 0;
@@ -71,4 +69,16 @@
       } break;
       }
+    } else if (typeid(matrix->GetDataType().GetElementDataType()) ==
+               typeid(UnsignedIntegerType)) {
+      switch (matrix->GetDataType().GetElementDataType().GetSize()) {
+      case 1: {
+        uint8_t uint8Value = matrix->Value(row, col);
+        memcpy(dst, &uint8Value, 1);
+      } break;
+      case 2: {
+        uint16_t uint16Value = matrix->Value(row, col);
+        memcpy(dst, &uint16Value, 2);
+      } break;
+      }
     }
   }
@@ -133,5 +143,5 @@
   if (row >= (uint32_t)pimpl_->descriptor->Rows() ||
       col >= (uint32_t)pimpl_->descriptor->Cols()) {
-    Warn("index (%i,%i) out of bound (%i,%i)\n", row, col,
+    Warn("index (%i,%i) out of bound, max (%i,%i)\n", row, col,
          pimpl_->descriptor->Rows() - 1, pimpl_->descriptor->Cols() - 1);
     return 0;
@@ -139,5 +149,5 @@
 
   GetMutex();
-  value = pimpl_->datas[row][col];
+  value = pimpl_->ValueNoMutex(row, col);
   ReleaseMutex();
 
@@ -148,10 +158,10 @@
   if (row >= (uint32_t)pimpl_->descriptor->Rows() ||
       col >= (uint32_t)pimpl_->descriptor->Cols()) {
-    Warn("index (%i,%i) out of bound (%i,%i)\n", row, col,
+    Warn("index (%i,%i) out of bound, max (%i,%i)\n", row, col,
          pimpl_->descriptor->Rows() - 1, pimpl_->descriptor->Cols() - 1);
     return 0;
   }
 
-  return pimpl_->datas[row][col];
+  return pimpl_->ValueNoMutex(row, col);
 }
 
@@ -159,9 +169,9 @@
   if (row >= (uint32_t)pimpl_->descriptor->Rows() ||
       col >= (uint32_t)pimpl_->descriptor->Cols()) {
-    Warn("index (%i,%i) out of bound (%i,%i)\n", row, col,
+    Warn("index (%i,%i) out of bound, max (%i,%i)\n", row, col,
          pimpl_->descriptor->Rows() - 1, pimpl_->descriptor->Cols() - 1);
   } else {
     GetMutex();
-    pimpl_->datas[row][col]=value;
+    pimpl_->SetValueNoMutex(row, col,value);
     ReleaseMutex();
   }
@@ -171,8 +181,8 @@
   if (row >= (uint32_t)pimpl_->descriptor->Rows() ||
       col >= (uint32_t)pimpl_->descriptor->Cols()) {
-    Warn("index (%i,%i) out of bound (%i,%i)\n", row, col,
+    Warn("index (%i,%i) out of bound, max (%i,%i)\n", row, col,
          pimpl_->descriptor->Rows() - 1, pimpl_->descriptor->Cols() - 1);
   } else {
-    pimpl_->datas[row][col]=value;
+    pimpl_->SetValueNoMutex(row, col,value);
   }
 }
@@ -180,5 +190,4 @@
 void Matrix::CopyDatas(char *dst) const {
   GetMutex();
-  // printf("%f %x %i\n",cvGetReal2D(pimpl_->mat,0,0),dst,Size());
   memcpy(dst, pimpl_->datas, dataType.GetSize());
   ReleaseMutex();
Index: /trunk/lib/FlairCore/src/Matrix.h
===================================================================
--- /trunk/lib/FlairCore/src/Matrix.h	(revision 213)
+++ /trunk/lib/FlairCore/src/Matrix.h	(revision 214)
@@ -27,6 +27,4 @@
 * \brief Class defining a matrix
 * 
-* Only supports float for the moment
-* TODO: write a template
 *
 */
@@ -196,5 +194,5 @@
 
   Type const &GetDataType() const { return dataType; };
-
+void CopyDatas(char *dst) const;
 private:
   /*!
@@ -206,5 +204,5 @@
   * \param dst destination buffer
   */
-  void CopyDatas(char *dst) const;
+  //void CopyDatas(char *dst) const;
 
   class Matrix_impl *pimpl_;
Index: /trunk/lib/FlairCore/src/Matrix_impl.cpp
===================================================================
--- /trunk/lib/FlairCore/src/Matrix_impl.cpp	(revision 213)
+++ /trunk/lib/FlairCore/src/Matrix_impl.cpp	(revision 214)
@@ -54,30 +54,16 @@
         dynamic_cast<ScalarType const &>(elementDataType);
     if (typeid(scalarType) == typeid(FloatType)) {
-      datas = (float **)malloc(descriptor->Rows() * sizeof(float*));
-      if(datas==NULL) {
-        self->Err("error allocating matrix\n");
-        return;
-      }
-      for(uint32_t i=0 ; i < descriptor->Rows() ; i++){
-        datas[i] = (float*)malloc(descriptor->Cols() * sizeof(float) ); 
-        if(datas[i]==NULL) {
-          self->Err("error allocating matrix\n");
-          for(uint32_t j = i-1 ; j >= 0 ; j--) free(datas[j]);
-          free(datas);
-          return;
-        }
-      }
-      /*
-    } else if (typeid(scalarType) == typeid(SignedIntegerType)) {
+      datas =malloc(descriptor->Rows() * descriptor->Cols() * sizeof(float));
+    } else if (typeid(scalarType) == typeid(SignedIntegerType) || typeid(scalarType) == typeid(UnsignedIntegerType) ) {
       switch (elementDataType.GetSize()) {
       case 1:
-        mat = cvCreateMat(descriptor->Rows(), descriptor->Cols(), CV_8SC1);
+        datas=malloc(descriptor->Rows() * descriptor->Cols() * sizeof(uint8_t));
         break;
       case 2:
-        mat = cvCreateMat(descriptor->Rows(), descriptor->Cols(), CV_16SC1);
+        datas=malloc(descriptor->Rows() * descriptor->Cols() * sizeof(uint16_t));
         break;
       default:
         self->Err("unsupported integer scalar type\n");
-      }*/
+      }
     } else {
       self->Err("unsupported scalar type\n");
@@ -94,8 +80,70 @@
 
 Matrix_impl::~Matrix_impl() {
-  for (uint32_t i = 0; i < descriptor->Rows();i++) {
-    free(datas[i]);
-  }
   free(datas);
   delete descriptor;
 }
+
+float Matrix_impl::ValueNoMutex(uint32_t row, uint32_t col) const {
+  ScalarType const &scalarType =
+        dynamic_cast<ScalarType const &>(elementDataType);
+  if (typeid(scalarType) == typeid(FloatType)) {
+    return ((float*)datas)[row*descriptor->Cols()+col];
+  } else if (typeid(scalarType) == typeid(SignedIntegerType)) {
+    switch (elementDataType.GetSize()) {
+    case 1:
+      return ((int8_t*)datas)[row*descriptor->Cols()+col];
+      break;
+    case 2:
+      return ((int16_t*)datas)[row*descriptor->Cols()+col];
+      break;
+    default:
+      self->Err("unsupported signed integer scalar type\n");
+    }
+  } else if (typeid(scalarType) == typeid(UnsignedIntegerType)) {
+    switch (elementDataType.GetSize()) {
+    case 1:
+      return ((uint8_t*)datas)[row*descriptor->Cols()+col];
+      break;
+    case 2:
+      return ((uint16_t*)datas)[row*descriptor->Cols()+col];
+      break;
+    default:
+      self->Err("unsupported unsigned integer scalar type\n");
+    }
+  } else {
+    self->Err("unsupported scalar type\n");
+  }
+  return 0;
+}
+
+void Matrix_impl::SetValueNoMutex(uint32_t row, uint32_t col, float value) {
+ ScalarType const &scalarType =
+        dynamic_cast<ScalarType const &>(elementDataType);
+  if (typeid(scalarType) == typeid(FloatType)) {
+    ((float*)datas)[row*descriptor->Cols()+col]=value;
+  } else if (typeid(scalarType) == typeid(SignedIntegerType)) {
+    switch (elementDataType.GetSize()) {
+    case 1:
+      ((int8_t*)datas)[row*descriptor->Cols()+col]=value;
+      break;
+    case 2:
+      ((int16_t*)datas)[row*descriptor->Cols()+col]=value;
+      break;
+    default:
+      self->Err("unsupported signed integer scalar type\n");
+    }
+  } else if (typeid(scalarType) == typeid(UnsignedIntegerType)) {
+    switch (elementDataType.GetSize()) {
+    case 1:
+      ((uint8_t*)datas)[row*descriptor->Cols()+col]=value;
+      break;
+    case 2:
+      ((uint16_t*)datas)[row*descriptor->Cols()+col]=value;
+      break;
+    default:
+      self->Err("unsupported unsigned integer scalar type\n");
+    }
+  } else {
+    self->Err("unsupported scalar type\n");
+  }
+}
Index: /trunk/lib/FlairCore/src/RangeFinderPlot.cpp
===================================================================
--- /trunk/lib/FlairCore/src/RangeFinderPlot.cpp	(revision 213)
+++ /trunk/lib/FlairCore/src/RangeFinderPlot.cpp	(revision 214)
@@ -18,6 +18,5 @@
 
 #include "RangeFinderPlot.h"
-#include "cvmatrix.h"
-#include "Layout.h"
+#include "Matrix.h"
 #include "LayoutPosition.h"
 #include <cxcore.h>
@@ -32,9 +31,9 @@
                                  string x_name, float xmin, float xmax,
                                  string y_name, float ymin, float ymax,
-                                 const cvmatrix *datas, float start_angle,
+                                 const Matrix *datas, float start_angle,
                                  float end_angle, uint32_t nb_samples)
     : SendData(position, name, "RangeFinderPlot", 200) {
   this->datas = datas;
-
+Warn("RangeFinderPlot::CopyDatas needs to be written\n");
   SetSendSize(datas->GetDataType().GetSize());
 
@@ -59,7 +58,5 @@
 
 void RangeFinderPlot::CopyDatas(char *buf) const {
-  datas->GetMutex();
-  memcpy(buf, datas->getCvMat()->data.ptr, datas->GetDataType().GetSize());
-  datas->ReleaseMutex();
+  //datas->CopyDatas(buf);
 }
 
Index: /trunk/lib/FlairCore/src/RangeFinderPlot.h
===================================================================
--- /trunk/lib/FlairCore/src/RangeFinderPlot.h	(revision 213)
+++ /trunk/lib/FlairCore/src/RangeFinderPlot.h	(revision 214)
@@ -20,5 +20,5 @@
 namespace flair {
 namespace core {
-class cvmatrix;
+class Matrix;
 }
 }
@@ -61,5 +61,5 @@
                   std::string x_name, float xmin, float xmax,
                   std::string y_name, float ymin, float ymax,
-                  const core::cvmatrix *datas, float start_angle,
+                  const core::Matrix *datas, float start_angle,
                   float end_angle, uint32_t nb_samples);
 
@@ -87,5 +87,5 @@
   void ExtraXmlEvent(void){};
 
-  const core::cvmatrix *datas;
+  const core::Matrix *datas;
 };
 
Index: /trunk/lib/FlairCore/src/cvmatrix.cpp
===================================================================
--- /trunk/lib/FlairCore/src/cvmatrix.cpp	(revision 213)
+++ /trunk/lib/FlairCore/src/cvmatrix.cpp	(revision 214)
@@ -37,5 +37,5 @@
     this->col = col;
     if (row >= matrix->Rows() || col >= matrix->Cols()) {
-      matrix->Err("index (%i,%i) out of bound (%i,%i)\n", row, col,
+      matrix->Err("index (%i,%i) out of bound, max (%i,%i)\n", row, col,
                   matrix->Rows() - 1, matrix->Cols() - 1);
       size = 0;
@@ -133,5 +133,5 @@
   if (row >= (uint32_t)pimpl_->mat->rows ||
       col >= (uint32_t)pimpl_->mat->cols) {
-    Warn("index (%i,%i) out of bound (%i,%i)\n", row, col,
+    Warn("index (%i,%i) out of bound, max (%i,%i)\n", row, col,
          pimpl_->mat->rows - 1, pimpl_->mat->cols - 1);
     return 0;
@@ -148,5 +148,5 @@
   if (row >= (uint32_t)pimpl_->mat->rows ||
       col >= (uint32_t)pimpl_->mat->cols) {
-    Warn("index (%i,%i) out of bound (%i,%i)\n", row, col,
+    Warn("index (%i,%i) out of bound, max (%i,%i)\n", row, col,
          pimpl_->mat->rows - 1, pimpl_->mat->cols - 1);
     return 0;
@@ -159,5 +159,5 @@
   if (row >= (uint32_t)pimpl_->mat->rows ||
       col >= (uint32_t)pimpl_->mat->cols) {
-    Warn("index (%i,%i) out of bound (%i,%i)\n", row, col,
+    Warn("index (%i,%i) out of bound, max (%i,%i)\n", row, col,
          pimpl_->mat->rows - 1, pimpl_->mat->cols - 1);
   } else {
@@ -171,5 +171,5 @@
   if (row >= (uint32_t)pimpl_->mat->rows ||
       col >= (uint32_t)pimpl_->mat->cols) {
-    Warn("index (%i,%i) out of bound (%i,%i)\n", row, col,
+    Warn("index (%i,%i) out of bound, max (%i,%i)\n", row, col,
          pimpl_->mat->rows - 1, pimpl_->mat->cols - 1);
   } else {
Index: /trunk/lib/FlairCore/src/cvmatrix_descriptor.cpp
===================================================================
--- /trunk/lib/FlairCore/src/cvmatrix_descriptor.cpp	(revision 213)
+++ /trunk/lib/FlairCore/src/cvmatrix_descriptor.cpp	(revision 214)
@@ -46,5 +46,5 @@
                                          string name) {
   if (row >= rows || col >= cols) {
-    getFrameworkManager()->Err("index out of bound %s (%i,%i), range (%i,%i)\n",
+    getFrameworkManager()->Err("index out of bound %s (%i,%i), max (%i,%i)\n",
                                name.c_str(), row, col, rows - 1, cols - 1);
     return;
@@ -55,5 +55,5 @@
 string cvmatrix_descriptor::ElementName(uint32_t row, uint32_t col) const {
   if (row >= rows || col >= cols) {
-    getFrameworkManager()->Err("index out of bound (%i,%i), range (%i,%i)\n",
+    getFrameworkManager()->Err("index out of bound (%i,%i), max (%i,%i)\n",
                                row, col, rows - 1, cols - 1);
     return *element_names[0]; // safe value...
Index: /trunk/lib/FlairCore/src/unexported/Matrix_impl.h
===================================================================
--- /trunk/lib/FlairCore/src/unexported/Matrix_impl.h	(revision 213)
+++ /trunk/lib/FlairCore/src/unexported/Matrix_impl.h	(revision 214)
@@ -33,5 +33,7 @@
   flair::core::ScalarType const &elementDataType;
   flair::core::cvmatrix_descriptor *descriptor;
-  float **datas;
+  void *datas;
+  void SetValueNoMutex(uint32_t row, uint32_t col, float value);
+  float ValueNoMutex(uint32_t row, uint32_t col) const;
 
 private:
Index: /trunk/lib/FlairCore/src/unexported/config.h
===================================================================
--- /trunk/lib/FlairCore/src/unexported/config.h	(revision 213)
+++ /trunk/lib/FlairCore/src/unexported/config.h	(revision 214)
@@ -27,5 +27,5 @@
 
 // nrt pipe size
-#define NRT_PIPE_SIZE 1024 * 100
+#define NRT_PIPE_SIZE 1024 * 100*10
 
 // rt log heap size
Index: /trunk/lib/FlairFilter/src/ButterworthLowPass.cpp
===================================================================
--- /trunk/lib/FlairFilter/src/ButterworthLowPass.cpp	(revision 213)
+++ /trunk/lib/FlairFilter/src/ButterworthLowPass.cpp	(revision 214)
@@ -18,5 +18,5 @@
 #include "ButterworthLowPass.h"
 #include "ButterworthLowPass_impl.h"
-#include <cvmatrix.h>
+#include <Matrix.h>
 #include <Layout.h>
 #include <LayoutPosition.h>
@@ -48,5 +48,5 @@
 ButterworthLowPass::~ButterworthLowPass() { delete pimpl_; }
 
-cvmatrix *ButterworthLowPass::Matrix(void) const { return pimpl_->output; }
+Matrix *ButterworthLowPass::GetMatrix(void) const { return pimpl_->output; }
 
 float ButterworthLowPass::Output(void) const {
Index: /trunk/lib/FlairFilter/src/ButterworthLowPass.h
===================================================================
--- /trunk/lib/FlairFilter/src/ButterworthLowPass.h	(revision 213)
+++ /trunk/lib/FlairFilter/src/ButterworthLowPass.h	(revision 214)
@@ -18,5 +18,5 @@
 namespace flair {
 namespace core {
-class cvmatrix;
+class Matrix;
 }
 namespace gui {
@@ -91,5 +91,5 @@
   * \return filtered output
   */
-  core::cvmatrix *Matrix(void) const;
+  core::Matrix *GetMatrix(void) const;
 
   /*!
Index: /trunk/lib/FlairFilter/src/ButterworthLowPass_impl.cpp
===================================================================
--- /trunk/lib/FlairFilter/src/ButterworthLowPass_impl.cpp	(revision 213)
+++ /trunk/lib/FlairFilter/src/ButterworthLowPass_impl.cpp	(revision 214)
@@ -18,5 +18,5 @@
 #include "ButterworthLowPass_impl.h"
 #include "ButterworthLowPass.h"
-#include <cvmatrix.h>
+#include <Matrix.h>
 #include <Layout.h>
 #include <GroupBox.h>
@@ -29,5 +29,5 @@
 using namespace flair::filter;
 
-ButterworthLowPass_impl::ButterworthLowPass_impl(ButterworthLowPass *self,
+ButterworthLowPass_impl::ButterworthLowPass_impl(const ButterworthLowPass *self,
                                                  const LayoutPosition *position,
                                                  string name, uint32_t order,uint32_t nbRow,uint32_t nbCol) {
@@ -41,5 +41,5 @@
   cvmatrix_descriptor *desc = new cvmatrix_descriptor(nbRow, nbCol);
   //desc->SetElementName(0, 0, "output");
-  output = new cvmatrix(self, desc, floatType, name);
+  output = new Matrix(self, desc, floatType, name);
   delete desc;
 
@@ -60,4 +60,5 @@
   this->nbRow=nbRow;
   this->nbCol=nbCol;
+  this->self=self;
 }
 
@@ -72,6 +73,11 @@
 
 void ButterworthLowPass_impl::UpdateFrom(const io_data *data) {
-  cvmatrix *input = (cvmatrix *)data;
   float delta_t;
+  const Matrix* input = dynamic_cast<const Matrix*>(data);
+  
+  if (!input) {
+      self->Warn("casting %s to Matrix failed\n",data->ObjectName().c_str());
+      return;
+  }
   
   if (T->ValueChanged() && T->Value() != 0) {
Index: /trunk/lib/FlairFilter/src/ControlLaw.cpp
===================================================================
--- /trunk/lib/FlairFilter/src/ControlLaw.cpp	(revision 213)
+++ /trunk/lib/FlairFilter/src/ControlLaw.cpp	(revision 214)
@@ -17,5 +17,5 @@
 
 #include "ControlLaw.h"
-#include <cvmatrix.h>
+#include <Matrix.h>
 #include <cvmatrix_descriptor.h>
 #include <DataPlot1D.h>
@@ -32,5 +32,5 @@
     : IODevice(parent, name) {
   if (nb_out == 1) {
-    output = new cvmatrix(this, nb_out, 1, floatType, name);
+    output = new Matrix(this, nb_out, 1, floatType, name);
   } else {
     cvmatrix_descriptor *desc = new cvmatrix_descriptor(nb_out, 1);
@@ -40,5 +40,5 @@
       desc->SetElementName(i, 0, ss.str());
     }
-    output = new cvmatrix(this, desc, floatType, name);
+    output = new Matrix(this, desc, floatType, name);
     delete desc;
   }
Index: /trunk/lib/FlairFilter/src/ControlLaw.h
===================================================================
--- /trunk/lib/FlairFilter/src/ControlLaw.h	(revision 213)
+++ /trunk/lib/FlairFilter/src/ControlLaw.h	(revision 214)
@@ -21,5 +21,5 @@
 }
 namespace core {
-class cvmatrix;
+class Matrix;
 }
 }
@@ -100,5 +100,5 @@
   *
   */
-  core::cvmatrix *input;
+  core::Matrix *input;
 
   /*!
@@ -109,5 +109,5 @@
   *
   */
-  core::cvmatrix *output;
+  core::Matrix *output;
 
 private:
Index: /trunk/lib/FlairFilter/src/EulerDerivative.cpp
===================================================================
--- /trunk/lib/FlairFilter/src/EulerDerivative.cpp	(revision 213)
+++ /trunk/lib/FlairFilter/src/EulerDerivative.cpp	(revision 214)
@@ -18,5 +18,5 @@
 #include "EulerDerivative.h"
 #include "EulerDerivative_impl.h"
-#include <cvmatrix.h>
+#include <Matrix.h>
 #include <LayoutPosition.h>
 
@@ -30,5 +30,5 @@
 EulerDerivative::EulerDerivative(const IODevice *parent,
                                  const LayoutPosition *position, string name,
-                                 const cvmatrix *init_value)
+                                 const Matrix *init_value)
     : IODevice(parent, name) {
   pimpl_ = new EulerDerivative_impl(this, position, name, init_value);
@@ -40,5 +40,5 @@
 EulerDerivative::~EulerDerivative() { delete pimpl_; }
 
-cvmatrix *EulerDerivative::Matrix(void) const { return pimpl_->output; }
+Matrix *EulerDerivative::GetMatrix(void) const { return pimpl_->output; }
 
 float EulerDerivative::Output(int row, int col) const {
Index: /trunk/lib/FlairFilter/src/EulerDerivative.h
===================================================================
--- /trunk/lib/FlairFilter/src/EulerDerivative.h	(revision 213)
+++ /trunk/lib/FlairFilter/src/EulerDerivative.h	(revision 214)
@@ -18,5 +18,5 @@
 namespace flair {
 namespace core {
-class cvmatrix;
+class Matrix;
 }
 namespace gui {
@@ -56,5 +56,5 @@
   EulerDerivative(const core::IODevice *parent,
                   const gui::LayoutPosition *position, std::string name,
-                  const core::cvmatrix *init_value = NULL);
+                  const core::Matrix *init_value = NULL);
 
   /*!
@@ -79,5 +79,5 @@
   * \return filtered output
   */
-  core::cvmatrix *Matrix(void) const;
+  core::Matrix *GetMatrix(void) const;
 
 private:
